/* reseni soustavy lin. alg. rovnic Gaussovou eliminacni metodou */
/* zadani rovnice v souboru                                      */


#include <stdio.h>
#include <stdlib.h>

typedef double *pd;

/* Alokace pameti na nedostatek pameti */

void *myall(unsigned kolik)
{
 void *p;
 if ((p=malloc(kolik))==NULL)
  {
   printf("\nNedostatek pameti!\n");
   exit(1);
  }
 return p;
}


/* Vypis soustavy rovnic - pole A a B */
void vyprov(int n, pd a, pd b)
{
 int i,j;
 pd px;
 for (i=0;i<n;i++)
   {
    px=a+n*i;
    for (j=0;j<n;j++)  printf("%+7.3f*%c  ", px[j],('Z'-n+1+j));
    printf("=%+7.3f\n", b[i]);
   }
}

/* Primy beh Gaussovy metody */
void gauss1(int n, pd a, pd b)
{
 int i,j,k;
 pd *mat,pr;
 double pom;

 mat=(pd *)myall(n*sizeof(pd));
 for (i=0;i<n;i++)
   mat[i]=a+n*i;

 for (k=1;k<n;k++)
   for (i=k;i<n;i++)
     {
      pom=mat[i][k-1]/mat[k-1][k-1];
      for (j=k-1;j<n;j++)
	mat[i][j]=mat[i][j]-pom*mat[k-1][j];
      b[i]=b[i]-pom*b[k-1];
     }

 free(mat);
}

/* Zpetny beh Gaussovy metody */
void gauss2(int n, pd a, pd b)
{
 int i,j,k;
 pd *mat,pr;
 double pom;

 mat=(pd *)myall(n*sizeof(pd));
 for (i=0;i<n;i++)
   mat[i]=a+n*i;

 for (k=n-2;k>=0;k--)
   for (i=k;i>=0;i--)
     {
      pom=mat[i][k+1]/mat[k+1][k+1];
      for (j=k;j<n;j++)
	mat[i][j]=mat[i][j]-pom*mat[k+1][j];
      b[i]=b[i]-pom*b[k+1];
     }

 for (i=0;i<n;i++)
  {
   b[i]/=mat[i][i];
   mat[i][i]=1.0;
  }

 free(mat);
}

void main()
{
 int rad;
 int i,j;
 pd A, B;
 FILE *fr;
 double X;
 char s[120];

 /* nacteni soustavy rovnic ze souboru */
 printf("\nZadej jmeno souboru s popisem soustavy rovnic: ");
 gets(s);
 fr=fopen(s, "r");
 if (fr==NULL) return;
 fscanf(fr, "%d", &rad);
 if (rad<2) {fclose(fr); return;}


 A=(pd)myall(rad*rad*sizeof(double));
 B=(pd)myall(rad*sizeof(double));

 for (i=0;i<rad;i++)
   {
    for (j=0;j<rad;j++)
      {
      fscanf(fr, "%lf", &X);
      *(A+rad*i+j)=X;
      }
    fscanf(fr, "%lf", B+i);
   }
 fclose(fr);

 printf("\nZadana soustava rovnic\n");
 vyprov(rad, A, B);

 /* primy beh */
 gauss1(rad, A, B);

 printf("Soustava rovnic po primem behu\n");
 vyprov(rad, A, B);

 /* zpetny beh */
 gauss2(rad, A, B);

 printf("Soustava rovnic po zpetnem behu\n");
 vyprov(rad, A, B);

 /* vypise reseni soustavy rovnic */
 printf("Reseni\n");
 for (i=0;i<rad;i++)
   printf("%c=%+7.3f  ", 'Z'-rad+1+i, B[i]);
 printf("\n");
 for (;getchar()!='\n';);

}
